import { ensureCollection } from 'debe';
import { addMiddleware, addPlugin } from 'debe-adapter';
import { syncstateTable } from './constants';
import { deltaPlugin } from 'debe-delta';
export function ensureSync(db) {
    var backend = db.dispatcher;
    if (backend.middlewares) {
        addMiddleware(backend, {
            name: 'sync',
            collection: function (collection) {
                if (collection['sync'] && collection['sync'] === 'delta') {
                    addPlugin(collection, 'delta');
                }
                return collection;
            },
            collections: function (collections) {
                collections[syncstateTable] = ensureCollection({
                    name: syncstateTable,
                    fields: {
                        state: 'json'
                    }
                });
                return collections;
            }
        });
        deltaPlugin(backend);
    }
}
//# sourceMappingURL=ensure-sync.js.map