import { Debe } from 'debe';
import { IAddress } from './types';
import { ISocket, IConnectionState } from 'debe-socket';
export * from './types';
export * from './constants';
export * from './utils';
import { SyncState } from './state';
import { SyncEngine } from './sync';
export declare class Sync {
    syncState: SyncState;
    engine: SyncEngine;
    socket: ISocket;
    db: Debe;
    where?: string[];
    constructor(db: Debe, [hostname, port, secure]?: IAddress);
    initialize(): Promise<this>;
    readonly initialSync: Promise<void>;
    readonly isSyncing: boolean;
    close(): Promise<void>;
    disconnect(): Promise<void>;
    connect(): Promise<void>;
    listener(): void;
    readonly state: IConnectionState;
    onConnectionState(func: (state: IConnectionState) => void): () => boolean;
    loop(): Promise<void>;
}
