import * as tslib_1 from "tslib";
import { create } from 'debe-socket';
export * from './types';
export * from './constants';
export * from './utils';
import { SyncState } from './state';
import { SyncEngine } from './sync';
import { ensureSync } from './ensure-sync';
var Sync = (function () {
    function Sync(db, _a) {
        var _b = tslib_1.__read(_a === void 0 ? [] : _a, 3), _c = _b[0], hostname = _c === void 0 ? 'localhost' : _c, _d = _b[1], port = _d === void 0 ? 8000 : _d, _e = _b[2], secure = _e === void 0 ? undefined : _e;
        this.db = db;
        this.syncState = new SyncState(db);
        ensureSync(this.db);
        this.db['sync'] = this;
        this.socket = create({
            secure: secure === true || secure === false ? secure : port === 443,
            hostname: hostname,
            port: port
        });
    }
    Sync.prototype.initialize = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.db.initialize()];
                    case 1:
                        _a.sent();
                        this.loop();
                        return [2, this];
                }
            });
        });
    };
    Object.defineProperty(Sync.prototype, "initialSync", {
        get: function () {
            return this.engine.initialSyncComplete;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sync.prototype, "isSyncing", {
        get: function () {
            return this.engine.isSyncing;
        },
        enumerable: true,
        configurable: true
    });
    Sync.prototype.close = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this['_close']) return [3, 2];
                        return [4, this['_close']()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this.socket.disconnect();
                        return [4, this.db.close()];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Sync.prototype.disconnect = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this['_close']) return [3, 2];
                        return [4, this['_close']()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this.socket.disconnect();
                        return [2];
                }
            });
        });
    };
    Sync.prototype.connect = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collections, isDelta, keys;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.db.initialize()];
                    case 1:
                        _a.sent();
                        return [4, this.syncState.init()];
                    case 2:
                        _a.sent();
                        this.engine = new SyncEngine(this.socket, this.db, this.syncState);
                        collections = this.db.dispatcher.collections;
                        isDelta = function (key) { return collections[key]['sync'] === 'delta'; };
                        keys = Object.keys(collections).filter(function (x) { return collections[x]['sync']; });
                        this.engine.initial(keys, isDelta);
                        this['_close'] = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                            return [2, this.engine.close()];
                        }); }); };
                        return [2];
                }
            });
        });
    };
    Sync.prototype.listener = function () { };
    Object.defineProperty(Sync.prototype, "state", {
        get: function () {
            return this.socket.state;
        },
        enumerable: true,
        configurable: true
    });
    Sync.prototype.onConnectionState = function (func) {
        var _this = this;
        var cancel = false;
        (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _a, _b, event_1, e_1_1;
            var e_1, _c;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 11]);
                        _a = tslib_1.__asyncValues(this.socket.listener('connect'));
                        _d.label = 1;
                    case 1: return [4, _a.next()];
                    case 2:
                        if (!(_b = _d.sent(), !_b.done)) return [3, 4];
                        event_1 = _b.value;
                        event_1;
                        if (cancel) {
                            return [2];
                        }
                        func(this.state);
                        _d.label = 3;
                    case 3: return [3, 1];
                    case 4: return [3, 11];
                    case 5:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3, 11];
                    case 6:
                        _d.trys.push([6, , 9, 10]);
                        if (!(_b && !_b.done && (_c = _a.return))) return [3, 8];
                        return [4, _c.call(_a)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        if (e_1) throw e_1.error;
                        return [7];
                    case 10: return [7];
                    case 11: return [2];
                }
            });
        }); })();
        (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _a, _b, event_2, e_2_1;
            var e_2, _c;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 11]);
                        _a = tslib_1.__asyncValues(this.socket.listener('disconnect'));
                        _d.label = 1;
                    case 1: return [4, _a.next()];
                    case 2:
                        if (!(_b = _d.sent(), !_b.done)) return [3, 4];
                        event_2 = _b.value;
                        event_2;
                        if (cancel) {
                            return [2];
                        }
                        func(this.state);
                        _d.label = 3;
                    case 3: return [3, 1];
                    case 4: return [3, 11];
                    case 5:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3, 11];
                    case 6:
                        _d.trys.push([6, , 9, 10]);
                        if (!(_b && !_b.done && (_c = _a.return))) return [3, 8];
                        return [4, _c.call(_a)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        if (e_2) throw e_2.error;
                        return [7];
                    case 10: return [7];
                    case 11: return [2];
                }
            });
        }); })();
        return function () { return (cancel = true); };
    };
    Sync.prototype.loop = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.state !== 'open')) return [3, 2];
                        return [4, this.socket.listener('connect').once()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (this.state !== 'open') {
                            this.loop();
                        }
                        else {
                            this.connect();
                        }
                        return [2];
                }
            });
        });
    };
    return Sync;
}());
export { Sync };
//# sourceMappingURL=index.js.map