(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('debe-socket'), require('debe-delta')) :
    typeof define === 'function' && define.amd ? define(['exports', 'debe-socket', 'debe-delta'], factory) :
    (global = global || self, factory(global.debe = global.debe || {}, global.debe, global.debe));
}(this, function (exports, debeSocket, debeDelta) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    var CHANNELS = {
        SEND: 'sendChanges',
        SEND_DELTA: 'sendDeltaChanges',
        COUNT_INITIAL: 'countInitialChanges',
        COUNT_INITIAL_DELTA: 'countInitialDeltaChanges',
        FETCH_INITIAL: 'fetchInitialChanges',
        FETCH_INITIAL_DELTA: 'fetchInitialDeltaChanges',
        FETCH_MISSING_DELTA: 'fetchMissingDelta',
        SUBSCRIBE_CHANGES: "subscription",
        SUBSCRIBE_DELTA_CHANGES: "subscribeDelta"
    };

    var syncstateTable = 'syncstate';
    var batchSize = 1000;

    function hashCode(str) {
        if (str === void 0) { str = ''; }
        var hash = 0, i, chr;
        if (str.length === 0)
            return hash;
        for (i = 0; i < str.length; i++) {
            chr = str.charCodeAt(i);
            hash = (hash << 5) - hash + chr;
            hash |= 0;
        }
        return hash;
    }
    function getLastItemRev(items, revField, comparer) {
        if (items === void 0) { items = []; }
        var result = items[items.length - 1]
            ? items[items.length - 1][revField]
            : undefined;
        if (!comparer || result > comparer) {
            return result;
        }
        return comparer;
    }
    var maxRetries = 5;
    var maxTimeout = 2500;
    var defaultInterval = function (tries) {
        switch (tries) {
            case 0:
                return 100;
            case 1:
                return 200;
            case 2:
                return 400;
            case 3:
                return 800;
            case 4:
                return 1600;
            default:
                return 3200;
        }
    };
    function waitFor(cb, _a) {
        var _b = (_a === void 0 ? {} : _a).interval, interval = _b === void 0 ? defaultInterval : _b;
        return __awaiter(this, void 0, void 0, function () {
            var tries, result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        tries = 0;
                        _c.label = 1;
                    case 1: return [4, cb()];
                    case 2:
                        if (!(!(result = _c.sent()) && tries <= maxRetries)) return [3, 4];
                        tries += 1;
                        return [4, new Promise(function (yay) {
                                return setTimeout(yay, typeof interval === 'function' ? interval(tries) : interval);
                            })];
                    case 3:
                        _c.sent();
                        return [3, 1];
                    case 4: return [2, Promise.resolve(result)];
                }
            });
        });
    }
    function getBigger(comparer0, comparer1) {
        if (!comparer0 || !comparer1) {
            return undefined;
        }
        if (!comparer1 || comparer0 > comparer1) {
            return comparer0;
        }
        return comparer1;
    }
    function batchTransfer(_a) {
        var fetchCount = _a.fetchCount, fetchItems = _a.fetchItems, transferItems = _a.transferItems, reporter = _a.reporter, shouldCancel = _a.shouldCancel;
        return __awaiter(this, void 0, void 0, function () {
            var canceled, changeCount, current, page, items, transferred, changes, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        canceled = shouldCancel ? shouldCancel : function () { return false; };
                        return [4, fetchCount()];
                    case 1:
                        changeCount = _d.sent();
                        current = changeCount;
                        page = 0;
                        items = [];
                        transferred = [];
                        _d.label = 2;
                    case 2:
                        if (!(current > 0)) return [3, 8];
                        return [4, fetchItems(page)];
                    case 3:
                        changes = _d.sent();
                        if (!(changes.length && !canceled())) return [3, 6];
                        if (!transferItems) return [3, 5];
                        _c = (_b = transferred).concat;
                        return [4, transferItems(changes)];
                    case 4:
                        transferred = _c.apply(_b, [_d.sent()]);
                        _d.label = 5;
                    case 5:
                        items = items.concat(changes);
                        return [3, 7];
                    case 6: return [3, 8];
                    case 7:
                        current = current - changes.length;
                        page = page + 1;
                        if (reporter) {
                            reporter(Math.abs((100 / changeCount) * current - 100));
                        }
                        return [3, 2];
                    case 8:
                        if (transferItems) {
                            return [2, [items, transferred]];
                        }
                        return [2, [items, []]];
                }
            });
        });
    }

    var SyncState = (function () {
        function SyncState(db) {
            var _this = this;
            this.state = {};
            this.local = function (collection) {
                if (!_this.state[collection]) {
                    return undefined;
                }
                return _this.state[collection].local;
            };
            this.remote = function (collection) {
                if (!_this.state[collection]) {
                    return undefined;
                }
                return _this.state[collection].remote;
            };
            this.promise = Promise.resolve();
            this.init = function () { return __awaiter(_this, void 0, void 0, function () {
                var state;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.db.get(syncstateTable)];
                        case 1:
                            state = _a.sent();
                            if (state) {
                                this.state = state;
                            }
                            return [2];
                    }
                });
            }); };
            this.update = function (collection, local, remote) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    if (!this.state[collection]) {
                        this.state[collection] = {};
                    }
                    if (local) {
                        this.state[collection].local = local;
                    }
                    if (remote) {
                        this.state[collection].remote = remote;
                    }
                    this.promise = this.promise.then(function () {
                        return _this.db.insert(syncstateTable, __assign({}, _this.state));
                    });
                    return [2];
                });
            }); };
            this.db = db;
        }
        return SyncState;
    }());

    var SEND_DELTA = CHANNELS.SEND_DELTA, FETCH_MISSING_DELTA = CHANNELS.FETCH_MISSING_DELTA;
    var delta = {
        initialDown: function (collection, since, count, sync) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, remoteChanges;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4, batchTransfer({
                                fetchCount: function () { return count; },
                                fetchItems: function (page) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        return [2, sync.socket.invoke(CHANNELS.FETCH_INITIAL_DELTA, {
                                                type: collection,
                                                since: since,
                                                page: page
                                            })];
                                    });
                                }); },
                                shouldCancel: function () { return sync.isClosing; }
                            })];
                        case 1:
                            _a = __read.apply(void 0, [_b.sent(), 1]), remoteChanges = _a[0];
                            if (remoteChanges.length && !sync.isClosing) {
                                return [2, function () { return __awaiter(_this, void 0, void 0, function () {
                                        var options, o;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    options = {
                                                        synced: 'client'
                                                    };
                                                    return [4, debeDelta.merge(sync.db, collection, remoteChanges, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                                                case 1:
                                                    _a.sent();
                                                    o = remoteChanges[remoteChanges.length - 1];
                                                    return [2, [undefined, o && o[2]]];
                                            }
                                        });
                                    }); }];
                            }
                            return [2, function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    return [2, [undefined, undefined]];
                                }); }); }];
                    }
                });
            });
        },
        initialUp: function (collection, since, count, sync) {
            return __awaiter(this, void 0, void 0, function () {
                var latestResult, latestUpload, err_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            latestResult = undefined;
                            latestUpload = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4, batchTransfer({
                                    fetchCount: function () { return count; },
                                    fetchItems: function (page) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            return [2, sync.db
                                                    .all(collection, {
                                                    where: since ? ['rev > ?', since] : undefined,
                                                    orderBy: ['rev ASC', 'id ASC'],
                                                    limit: batchSize,
                                                    offset: page * batchSize
                                                })
                                                    .then(function (x) {
                                                    if (x.length) {
                                                        latestUpload = x[x.length - 1].rev;
                                                    }
                                                    return x;
                                                })];
                                        });
                                    }); },
                                    transferItems: function (items) {
                                        return delta
                                            .up(collection, items, {
                                            delta: items.map(function (x) { return [x.id, x['merge'], x.rev]; })
                                        }, sync)
                                            .then(function (x) {
                                            latestResult = x;
                                            return x;
                                        });
                                    },
                                    shouldCancel: function () { return sync.isClosing; }
                                })];
                        case 2:
                            _a.sent();
                            return [2, [latestUpload, latestResult ? latestResult.latestRev : undefined]];
                        case 3:
                            err_1 = _a.sent();
                            return [2, [undefined, undefined]];
                        case 4: return [2];
                    }
                });
            });
        },
        listen: function (sync) {
            var _this = this;
            var channel = sync.socket.subscribe(CHANNELS.SUBSCRIBE_DELTA_CHANGES);
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var channel_1, channel_1_1, data, release, _a, type, items, _b, options, newItems, result, o0, o, e_1_1;
                var e_1, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 10, 11, 16]);
                            channel_1 = __asyncValues(channel);
                            _d.label = 1;
                        case 1: return [4, channel_1.next()];
                        case 2:
                            if (!(channel_1_1 = _d.sent(), !channel_1_1.done)) return [3, 9];
                            data = channel_1_1.value;
                            if (sync.isClosing) {
                                return [2];
                            }
                            return [4, sync.initialSyncComplete];
                        case 3:
                            _d.sent();
                            release = sync.registerTask();
                            _a = __read(data, 3), type = _a[0], items = _a[1], _b = _a[2], options = _b === void 0 ? {} : _b;
                            options.synced = sync.socket.id;
                            return [4, debeDelta.merge(sync.db, type, items, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                        case 4:
                            newItems = _d.sent();
                            if (!options.unsucessful.length) return [3, 7];
                            return [4, sync.socket.invoke(FETCH_MISSING_DELTA, [
                                    type,
                                    options.unsucessful
                                ])];
                        case 5:
                            result = _d.sent();
                            return [4, debeDelta.merge(sync.db, type, result, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                        case 6:
                            newItems = _d.sent();
                            _d.label = 7;
                        case 7:
                            o0 = newItems[newItems.length - 1];
                            o = items[items.length - 1];
                            sync.syncState.update(type, o0 ? o0.rev : undefined, o && o[2]);
                            release();
                            _d.label = 8;
                        case 8: return [3, 1];
                        case 9: return [3, 16];
                        case 10:
                            e_1_1 = _d.sent();
                            e_1 = { error: e_1_1 };
                            return [3, 16];
                        case 11:
                            _d.trys.push([11, , 14, 15]);
                            if (!(channel_1_1 && !channel_1_1.done && (_c = channel_1.return))) return [3, 13];
                            return [4, _c.call(channel_1)];
                        case 12:
                            _d.sent();
                            _d.label = 13;
                        case 13: return [3, 15];
                        case 14:
                            if (e_1) throw e_1.error;
                            return [7];
                        case 15: return [7];
                        case 16: return [2];
                    }
                });
            }); })();
            return {
                wait: new Promise(function (yay) { return setTimeout(yay, 10); })
            };
        },
        up: function (collection, items, options, sync) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, failed, latestRev, missing;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (sync.isClosing) {
                                return [2];
                            }
                            return [4, sync.socket.invoke(SEND_DELTA, [collection, options['delta']])];
                        case 1:
                            _a = _c.sent(), _b = _a.failed, failed = _b === void 0 ? [] : _b, latestRev = _a.latestRev;
                            if (sync.isClosing) {
                                return [2];
                            }
                            if (!failed.length) return [3, 4];
                            return [4, sync.db.all(collection, {
                                    id: failed,
                                    select: ['id', 'merge']
                                })];
                        case 2:
                            missing = _c.sent();
                            if (sync.isClosing) {
                                return [2];
                            }
                            return [4, sync.socket
                                    .invoke(SEND_DELTA, [collection, missing.map(function (x) { return [x.id, x['merge']]; })])
                                    .then(function (x) { return (x.latestRev > latestRev ? x.latestRev : latestRev); })];
                        case 3:
                            latestRev = _c.sent();
                            _c.label = 4;
                        case 4: return [2, latestRev];
                    }
                });
            });
        }
    };

    var basic = {
        initialDown: function (collection, since, count, sync) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, remoteChanges;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4, batchTransfer({
                                fetchCount: function () { return count; },
                                fetchItems: function (page) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        return [2, sync.socket.invoke(CHANNELS.FETCH_INITIAL, {
                                                type: collection,
                                                since: since,
                                                page: page
                                            })];
                                    });
                                }); },
                                shouldCancel: function () { return sync.isClosing; }
                            })];
                        case 1:
                            _a = __read.apply(void 0, [_b.sent(), 1]), remoteChanges = _a[0];
                            return [2, function () { return __awaiter(_this, void 0, void 0, function () {
                                    var options, o;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (!(remoteChanges.length && !sync.isClosing)) return [3, 2];
                                                options = {
                                                    synced: 'client'
                                                };
                                                return [4, sync.db.insert(collection, remoteChanges, options)];
                                            case 1:
                                                _a.sent();
                                                o = remoteChanges[remoteChanges.length - 1];
                                                return [2, [undefined, o && o[2]]];
                                            case 2: return [2, [undefined, undefined]];
                                        }
                                    });
                                }); }];
                    }
                });
            });
        },
        initialUp: function (collection, since, count, sync) {
            return __awaiter(this, void 0, void 0, function () {
                var latestResult, latestUpload, err_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            latestResult = undefined;
                            latestUpload = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4, batchTransfer({
                                    fetchCount: function () { return count; },
                                    fetchItems: function (page) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            return [2, sync.db
                                                    .all(collection, {
                                                    where: since ? ['rev > ?', since] : undefined,
                                                    orderBy: ['rev ASC', 'id ASC'],
                                                    limit: batchSize,
                                                    offset: page * batchSize
                                                })
                                                    .then(function (x) {
                                                    if (x.length) {
                                                        latestUpload = x[x.length - 1].rev;
                                                    }
                                                    return x;
                                                })];
                                        });
                                    }); },
                                    transferItems: function (items) { return basic.up(collection, items, {}, sync); },
                                    shouldCancel: function () { return sync.isClosing; }
                                })];
                        case 2:
                            _a.sent();
                            return [2, [latestUpload, latestResult ? latestResult.latestRev : undefined]];
                        case 3:
                            err_1 = _a.sent();
                            return [2, [undefined, undefined]];
                        case 4: return [2];
                    }
                });
            });
        },
        listen: function (sync) {
            var _this = this;
            var channel = sync.socket.subscribe(CHANNELS.SUBSCRIBE_CHANGES);
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var channel_1, channel_1_1, data, _a, type, items, _b, options, release, lastRemoteRev, newItems, lastLocalRev, e_1_1;
                var e_1, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 7, 8, 13]);
                            channel_1 = __asyncValues(channel);
                            _d.label = 1;
                        case 1: return [4, channel_1.next()];
                        case 2:
                            if (!(channel_1_1 = _d.sent(), !channel_1_1.done)) return [3, 6];
                            data = channel_1_1.value;
                            if (sync.isClosing) {
                                return [2];
                            }
                            return [4, sync.initialSyncComplete];
                        case 3:
                            _d.sent();
                            _a = __read(data, 3), type = _a[0], items = _a[1], _b = _a[2], options = _b === void 0 ? {} : _b;
                            release = sync.registerTask();
                            options.synced = sync.socket.id;
                            lastRemoteRev = items[items.length - 1] && items[items.length - 1].rev;
                            return [4, sync.db.insert(type, items, options)];
                        case 4:
                            newItems = _d.sent();
                            lastLocalRev = newItems[newItems.length - 1] && newItems[newItems.length - 1].rev;
                            sync.syncState.update(type, lastLocalRev, lastRemoteRev);
                            release();
                            _d.label = 5;
                        case 5: return [3, 1];
                        case 6: return [3, 13];
                        case 7:
                            e_1_1 = _d.sent();
                            e_1 = { error: e_1_1 };
                            return [3, 13];
                        case 8:
                            _d.trys.push([8, , 11, 12]);
                            if (!(channel_1_1 && !channel_1_1.done && (_c = channel_1.return))) return [3, 10];
                            return [4, _c.call(channel_1)];
                        case 9:
                            _d.sent();
                            _d.label = 10;
                        case 10: return [3, 12];
                        case 11:
                            if (e_1) throw e_1.error;
                            return [7];
                        case 12: return [7];
                        case 13: return [2];
                    }
                });
            }); })();
            return {
                wait: new Promise(function (yay) { return setTimeout(yay, 10); })
            };
        },
        up: function (collection, items, options, sync) {
            if (sync.isClosing) {
                return Promise.resolve();
            }
            return sync.socket
                .invoke(CHANNELS.SEND, [collection, items])
                .catch(function (err) {
                if (!sync.isClosing) {
                    throw err;
                }
            });
        }
    };

    var SyncEngine = (function () {
        function SyncEngine(socket, db, state) {
            this.initialSyncComplete = Promise.resolve();
            this.cancels = [];
            this.tasks = {};
            this.isClosing = false;
            this.socket = socket;
            this.db = db;
            this.syncState = state;
        }
        Object.defineProperty(SyncEngine.prototype, "isInitialComplete", {
            get: function () {
                return this.tasks['initial'] !== true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncEngine.prototype, "isSyncing", {
            get: function () {
                return Object.keys(this.tasks).length > 0;
            },
            enumerable: true,
            configurable: true
        });
        SyncEngine.prototype.initial = function (collections, isDelta) {
            var release = this.registerTask('initial');
            this.initialSyncComplete = this.initialSync(collections, isDelta).finally(function () {
                release();
            });
            this.cancels.push(this.listenToDatabase(collections, isDelta));
            this.listenToSync();
        };
        SyncEngine.prototype.close = function () {
            var _this = this;
            this.isClosing = true;
            this['_close'] = function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, Promise.all(this.cancels.map(function (x) { return x(); }))];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            }); };
        };
        SyncEngine.prototype.listenToSync = function () {
            var cancels = [];
            cancels.push(delta.listen(this));
            cancels.push(basic.listen(this));
        };
        SyncEngine.prototype.getRemoteChangeCount = function (socket, collections, syncState) {
            return __awaiter(this, void 0, void 0, function () {
                var remoteCounts;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            remoteCounts = {};
                            return [4, Promise.all(collections.map(function (key) {
                                    return socket
                                        .invoke(CHANNELS.COUNT_INITIAL_DELTA, {
                                        type: key,
                                        since: syncState.remote(key)
                                    })
                                        .then(function (result) { return (remoteCounts[key] = result); });
                                }))];
                        case 1:
                            _a.sent();
                            return [2, remoteCounts];
                    }
                });
            });
        };
        SyncEngine.prototype.getLocalChangeCount = function (db, collections, syncState) {
            return __awaiter(this, void 0, void 0, function () {
                var localCounts;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            localCounts = {};
                            return [4, Promise.all(collections.map(function (key) {
                                    var begin = syncState.local(key);
                                    return db
                                        .count(key, {
                                        where: begin ? ['rev > ?', begin] : undefined
                                    })
                                        .then(function (result) { return (localCounts[key] = result); });
                                }))];
                        case 1:
                            _a.sent();
                            return [2, localCounts];
                    }
                });
            });
        };
        SyncEngine.prototype.getTaskKey = function () {
            var key = new Date().getTime();
            var count = 0;
            while (this.tasks[key + "-" + count] !== undefined) {
                count = count + 1;
            }
            return key + "-" + count;
        };
        SyncEngine.prototype.registerTask = function (initialKey) {
            var _this = this;
            var key = initialKey || this.getTaskKey();
            this.tasks[key] = true;
            return function () {
                delete _this.tasks[key];
            };
        };
        SyncEngine.prototype.listenToDatabase = function (collections, isDelta) {
            var _this = this;
            return this.db.listen('*', function (error, items, options, key) { return __awaiter(_this, void 0, void 0, function () {
                var release;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (error) {
                                throw error;
                            }
                            return [4, this.initialSyncComplete];
                        case 1:
                            _a.sent();
                            if (this.socket.state !== 'open') {
                                return [2];
                            }
                            release = this.registerTask();
                            if (!key ||
                                collections.indexOf(key) === -1 ||
                                options.synced === this.socket.id) {
                                return [2];
                            }
                            if (isDelta(key)) {
                                delta.up(key, items, options, this);
                            }
                            else {
                                basic
                                    .up(key, items, options, this)
                                    .catch(function (err) { return console.log('ERR', err, err.stack, _this.socket.state); })
                                    .finally(function () {
                                    release();
                                });
                            }
                            return [2];
                    }
                });
            }); });
        };
        SyncEngine.prototype.initialSync = function (collections, isDelta) {
            return __awaiter(this, void 0, void 0, function () {
                var remoteCounts, localCounts, collections_1, collections_1_1, key, down, persist, up, _a, local2, remote2, _b, local, remote, e_1_1;
                var e_1, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0: return [4, this.getRemoteChangeCount(this.socket, collections, this.syncState)];
                        case 1:
                            remoteCounts = _d.sent();
                            return [4, this.getLocalChangeCount(this.db, collections, this.syncState)];
                        case 2:
                            localCounts = _d.sent();
                            _d.label = 3;
                        case 3:
                            _d.trys.push([3, 10, 11, 12]);
                            collections_1 = __values(collections), collections_1_1 = collections_1.next();
                            _d.label = 4;
                        case 4:
                            if (!!collections_1_1.done) return [3, 9];
                            key = collections_1_1.value;
                            down = isDelta(key) ? delta.initialDown : basic.initialDown;
                            return [4, down(key, this.syncState.remote(key), remoteCounts[key], this)];
                        case 5:
                            persist = _d.sent();
                            up = isDelta(key) ? delta.initialUp : basic.initialUp;
                            return [4, up(key, this.syncState.local(key), localCounts[key], this)];
                        case 6:
                            _a = __read.apply(void 0, [_d.sent(), 2]), local2 = _a[0], remote2 = _a[1];
                            return [4, persist()];
                        case 7:
                            _b = __read.apply(void 0, [_d.sent(), 2]), local = _b[0], remote = _b[1];
                            this.syncState.update(key, local, remote);
                            this.syncState.update(key, local2, remote2);
                            _d.label = 8;
                        case 8:
                            collections_1_1 = collections_1.next();
                            return [3, 4];
                        case 9: return [3, 12];
                        case 10:
                            e_1_1 = _d.sent();
                            e_1 = { error: e_1_1 };
                            return [3, 12];
                        case 11:
                            try {
                                if (collections_1_1 && !collections_1_1.done && (_c = collections_1.return)) _c.call(collections_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7];
                        case 12: return [2];
                    }
                });
            });
        };
        return SyncEngine;
    }());

    function addToQuery(query, type, additional) {
        if (type === void 0) { type = 'AND'; }
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        if (!query) {
            return __spread([additional], args);
        }
        else {
            var _a = __read(query), arg0 = _a[0], rest = _a.slice(1);
            return __spread([arg0 + " " + type + " " + additional], rest, args);
        }
    }
    function and(query, additional) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return addToQuery.apply(void 0, __spread([query, 'AND', additional], args));
    }
    function isNull(field) {
        return field + " IS NULL";
    }

    function chunk(list, chunkSize) {
        if (chunkSize === void 0) { chunkSize = 10000; }
        return new Array(Math.ceil(list.length / chunkSize))
            .fill(0)
            .map(function (_, i) {
            return list.slice(i * chunkSize, i * chunkSize + chunkSize);
        });
    }
    function chunkSequencial(items, max, work) {
        if (max === void 0) { max = 1000; }
        return __awaiter(this, void 0, void 0, function () {
            var results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        return [4, chunk(items, max).reduce(function (state, items) {
                                return state.then(function () {
                                    return work(items).then(function (result) { return (results = results.concat(result)); });
                                });
                            }, Promise.resolve())];
                    case 1:
                        _a.sent();
                        return [2, results];
                }
            });
        });
    }
    function chunkParallel(items, max, work) {
        if (max === void 0) { max = 1000; }
        return __awaiter(this, void 0, void 0, function () {
            var results, resultSet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        return [4, Promise.all(chunk(items, max).map(function (items) { return work(items); }))];
                    case 1:
                        resultSet = _a.sent();
                        resultSet.forEach(function (result) { return (results = results.concat(result)); });
                        return [2, results];
                }
            });
        });
    }

    var fieldTypes = {
        NUMBER: 'number',
        BOOLEAN: 'boolean',
        STRING: 'string',
        JSON: 'json'
    };

    function ensureCollection(collection) {
        if (!collection.fields) {
            collection.fields = {};
        }
        else if (Array.isArray(collection.fields)) {
            collection.fields = collection.fields.reduce(function (result, field) {
                var _a;
                return (__assign({}, result, (_a = {}, _a[field] = fieldTypes.STRING, _a)));
            }, {});
        }
        if (!collection.index) {
            collection.index = {};
        }
        else if (Array.isArray(collection.index)) {
            collection.index = collection.index.reduce(function (result, field) {
                var _a;
                return (__assign({}, result, (_a = {}, _a[field] = fieldTypes.STRING, _a)));
            }, {});
        }
        if (!collection.plugins) {
            collection.plugins = [];
        }
        if (!collection.specialFields) {
            collection.specialFields = {};
        }
        return collection;
    }

    var DebeDispatcher = (function () {
        function DebeDispatcher() {
        }
        return DebeDispatcher;
    }());

    var crypto = self.crypto || self.msCrypto;

    /*
     * This alphabet uses a-z A-Z 0-9 _- symbols.
     * Symbols order was changed for better gzip compression.
     */
    var url = 'Uint8ArdomValuesObj012345679BCDEFGHIJKLMNPQRSTWXYZ_cfghkpqvwxyz-';

    var index_browser = function (size) {
      size = size || 21;
      var id = '';
      var bytes = crypto.getRandomValues(new Uint8Array(size));
      while (0 < size--) {
        id += url[bytes[size] & 63];
      }
      return id
    };

    var _generate = index_browser;
    function generate(size) {
        return _generate(size);
    }
    var me;
    if (typeof global !== 'undefined' && global['window']) {
        me = global['window'];
    }
    else if (typeof global !== 'undefined' && global['self']) {
        me = global['self'];
    }
    if (me && typeof _generate !== 'function') {
        var crypto_1 = me.crypto || me['msCrypto'];
        if (crypto_1) {
            var url_1 = 'Uint8ArdomValuesObj012345679BCDEFGHIJKLMNPQRSTWXYZ_cfghkpqvwxyz-';
            _generate = function (size) {
                size = size || 21;
                var id = '';
                var bytes = crypto_1.getRandomValues(new Uint8Array(size));
                while (0 < size--) {
                    id += url_1[bytes[size] & 63];
                }
                return id;
            };
        }
    }

    function hasMiddleware(dispatcher, name) {
        if (!name) {
            return false;
        }
        return !!dispatcher.middlewares.find(function (x) { return x.name === name; });
    }
    function addMiddleware(dispatcher, middleware) {
        if (!dispatcher.middlewares) {
            throw new Error('Dispatcher has no middlewares. Make sure this is a BackendDispatcher');
        }
        if (hasMiddleware(dispatcher, middleware.name)) {
            return;
        }
        dispatcher.middlewares.push(middleware);
    }

    function hasPlugin(collection, name) {
        return collection.plugins.indexOf(name) !== -1;
    }
    function addPlugin(collection, name) {
        if (hasPlugin(collection, name)) {
            return;
        }
        return collection.plugins.push(name);
    }

    function objectify(array, map) {
        return array.reduce(function (store, x) {
            store[x.name] = map ? map(x) : x;
            return store;
        }, {});
    }
    var isNullOrUndefined = function (x) { return x === null || x === undefined; };
    function isEqual(rowsA, rowsB, revisionField) {
        if (revisionField === void 0) { revisionField = 'rev'; }
        if (Array.isArray(rowsA) && rowsA.length === 0) {
            rowsA = null;
        }
        if (Array.isArray(rowsB) && rowsB.length === 0) {
            rowsB = null;
        }
        if (rowsA === rowsB) {
            return true;
        }
        if (isNullOrUndefined(rowsA) && isNullOrUndefined(rowsB)) {
            return true;
        }
        if ((!rowsA && rowsB) || (rowsA && !rowsB)) {
            return false;
        }
        if (typeof rowsA === 'bigint' ||
            typeof rowsA === 'boolean' ||
            typeof rowsA === 'number' ||
            typeof rowsA === 'string') {
            return rowsA === rowsB;
        }
        if (rowsA instanceof Date) {
            if (!(rowsB instanceof Date)) {
                return false;
            }
            return +rowsA === +rowsB;
        }
        function extrapolate(item) {
            return item.id + "|" + item[revisionField];
        }
        function isEqualSingle(itemA, itemB) {
            if (itemA === itemB) {
                return true;
            }
            if (!itemA && !itemB) {
                return true;
            }
            if ((!itemA && itemB) || (itemA && !itemB)) {
                return false;
            }
            return extrapolate(itemA) === extrapolate(itemB);
        }
        if (!Array.isArray(rowsA) && !Array.isArray(rowsB)) {
            return isEqualSingle(rowsA, rowsB);
        }
        if (rowsA.length !== rowsB.length) {
            return false;
        }
        if (rowsA.map(extrapolate).join('|') !==
            rowsB.map(extrapolate).join('|')) {
            return false;
        }
        return true;
    }
    var Emitter = (function () {
        function Emitter() {
            this.listeners = {};
        }
        Object.defineProperty(Emitter.prototype, "numberOfListeners", {
            get: function () {
                var _this = this;
                return Object.keys(this.listeners).reduce(function (state, key) { return state + _this.listeners[key].length; }, 0);
            },
            enumerable: true,
            configurable: true
        });
        Emitter.prototype.proxyTo = function (obj) {
            obj.once = this.once;
            obj.on = this.on;
            obj.emit = this.emit;
            obj.listeners = this.listeners;
            obj.$args = this.$args;
            obj.$o = this.$o;
        };
        Emitter.prototype.$args = function (nameOrListener, mayBeListener) {
            if (!mayBeListener && typeof nameOrListener === 'function') {
                return ['*', nameOrListener];
            }
            else if (mayBeListener && typeof nameOrListener === 'string') {
                return [nameOrListener, mayBeListener];
            }
            else {
                throw new Error('Please provide either name and listener or only listener to on function');
            }
        };
        Emitter.prototype.$o = function (name, listener) {
            var _this = this;
            this.listeners[name] = this.listeners[name] || [];
            this.listeners[name].push(listener);
            return function () {
                var index = _this.listeners[name].indexOf(listener);
                if (index !== -1) {
                    _this.listeners[name].splice(index, 1);
                }
            };
        };
        Emitter.prototype.on = function (nameOrListener, mayBeListener) {
            var _a = __read(this.$args(nameOrListener, mayBeListener), 2), name = _a[0], listener = _a[1];
            return this.$o(name, listener);
        };
        Emitter.prototype.once = function (nameOrListener, mayBeListener) {
            var _a = __read(this.$args(nameOrListener, mayBeListener), 2), name = _a[0], listener = _a[1];
            var unlisten = this.$o(name, function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                unlisten();
                listener.apply(void 0, __spread(args));
            });
            return unlisten;
        };
        Emitter.prototype.close = function () {
            this.listeners = {};
        };
        Emitter.prototype.emit = function (name) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var listeners = __spread((this.listeners[name] || []), (this.listeners['*'] || []));
            var i = listeners.length;
            var promises = [];
            if (listeners.length) {
                while (i--) {
                    var result = listeners[i].apply(listeners, __spread(args));
                    if (result && result.then) {
                        promises.push(result);
                    }
                }
            }
            return Promise.all(promises);
        };
        return Emitter;
    }());

    var defaultRevisionField = 'rev';
    var counter = -1;
    var lastTime = '';
    var getTime = function () {
        var newTime = new Date().toISOString();
        if (newTime === lastTime) {
            counter = counter + 1;
            return newTime + ("" + counter).padStart(5, '0');
        }
        counter = -1;
        lastTime = newTime;
        return lastTime + '00000';
    };
    function changeListenerPlugin(adapter, _a) {
        var _b = _a.emitter, emitter = _b === void 0 ? new Emitter() : _b, _c = _a.revField, revField = _c === void 0 ? defaultRevisionField : _c;
        var addRev = function (item) {
            if (!item) {
                return item;
            }
            item[revField] = getTime();
            return item;
        };
        addMiddleware(adapter, {
            listener: function (method, _a, callback) {
                var _this = this;
                if (method === void 0) { method = 'insert'; }
                var _b = _a.collection, collection = _b === void 0 ? '*' : _b, query = _a.query;
                if (method === 'insert') {
                    return emitter.on(collection, callback);
                }
                var lastResult = undefined;
                var listener = function () { return __awaiter(_this, void 0, void 0, function () {
                    var newValue, err_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4, adapter.db[method](collection, query)];
                            case 1:
                                newValue = _a.sent();
                                if (!isEqual(lastResult, newValue, revField)) {
                                    callback(null, (newValue === null ? undefined : newValue));
                                }
                                lastResult = newValue || null;
                                return [3, 3];
                            case 2:
                                err_1 = _a.sent();
                                callback(err_1, undefined);
                                return [3, 3];
                            case 3: return [2];
                        }
                    });
                }); };
                listener();
                return emitter.on(collection, listener);
            },
            transformItemIn: function (collection, item) {
                return addRev(item);
            },
            afterInsert: function (collection, items, options) {
                if (options === void 0) { options = {}; }
                emitter.emit(collection.name, null, items, options, collection.name);
            },
            afterRemove: function (collection, items, options) {
                if (options === void 0) { options = {}; }
                emitter.emit(collection.name, null, items, options, collection.name);
            },
            collection: function (collection) {
                collection.specialFields.rev = revField;
                collection.fields[revField] = 'string';
                collection.index[revField] = 'string';
                return collection;
            }
        });
    }

    function softDeletePlugin(adapter, _a) {
        var _b = _a.removedField, removedField = _b === void 0 ? 'rem' : _b;
        addMiddleware(adapter, {
            name: 'softDelete',
            collection: function (collection) {
                collection.specialFields.rem = removedField;
                collection.fields[removedField] = 'string';
                collection.index[removedField] = 'string';
                return collection;
            },
            query: function (collection, query) {
                return __assign({}, query, { where: and(query.where, isNull(removedField)) });
            },
            beforeRemove: function (collection, ids) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, adapter.db.insert(collection.name, ids.map(function (id) {
                                    var _a;
                                    return (_a = {
                                            id: id
                                        },
                                        _a[removedField] = new Date().toISOString(),
                                        _a);
                                }))];
                            case 1:
                                _a.sent();
                                return [2, ids];
                        }
                    });
                });
            }
        });
    }

    var DebeBackend = (function (_super) {
        __extends(DebeBackend, _super);
        function DebeBackend(adapter, collections, options) {
            var e_1, _a;
            if (options === void 0) { options = {}; }
            var _this = _super.call(this) || this;
            _this.chunks = 1000000;
            _this.chunkMode = 'parallel';
            _this.collections = {};
            _this.middlewares = [];
            _this.collections = Array.isArray(collections)
                ? objectify(collections, ensureCollection)
                : collections;
            _this.options = options;
            _this.adapter = adapter;
            var _b = options.middlewares, middlewares = _b === void 0 ? [] : _b, _c = options.changeListener, changeListener = _c === void 0 ? true : _c, _d = options.softDelete, softDelete = _d === void 0 ? false : _d;
            if (changeListener) {
                changeListenerPlugin(_this, options);
            }
            if (softDelete) {
                softDeletePlugin(_this, options);
            }
            try {
                for (var middlewares_1 = __values(middlewares), middlewares_1_1 = middlewares_1.next(); !middlewares_1_1.done; middlewares_1_1 = middlewares_1.next()) {
                    var middleware = middlewares_1_1.value;
                    middleware(_this, options);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (middlewares_1_1 && !middlewares_1_1.done && (_a = middlewares_1.return)) _a.call(middlewares_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return _this;
        }
        DebeBackend.prototype.run = function (action, collection, payload, options) {
            if (this[action]) {
                return this[action].apply(this, [collection, payload, options]);
            }
        };
        DebeBackend.prototype.listen = function (action, callback, options) {
            return this.listener(action, callback, options);
        };
        DebeBackend.prototype.collection = function (name) {
            return this.collections[name];
        };
        DebeBackend.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.adapter.close()];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            });
        };
        DebeBackend.prototype.initialize = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, middleware, key, _c, _d, middleware;
                var e_2, _e, e_3, _f;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            this.options = { idField: this.options.idField || 'id' };
                            try {
                                for (_a = __values(this.middlewares), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    middleware = _b.value;
                                    if (middleware.collections) {
                                        middleware.collections(this.collections);
                                    }
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            for (key in this.collections) {
                                this.collections[key].fields[this.options.idField] = 'string';
                                this.collections[key].index[this.options.idField] = 'string';
                                this.collections[key].specialFields.id = this.options.idField;
                                try {
                                    for (_c = (e_3 = void 0, __values(this.middlewares)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                        middleware = _d.value;
                                        if (middleware.collection) {
                                            middleware.collection(this.collections[key]);
                                        }
                                    }
                                }
                                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                finally {
                                    try {
                                        if (_d && !_d.done && (_f = _c.return)) _f.call(_c);
                                    }
                                    finally { if (e_3) throw e_3.error; }
                                }
                            }
                            this.collections = this.collections;
                            return [4, this.adapter.initialize(this.collections, this.options)];
                        case 1:
                            _g.sent();
                            return [2];
                    }
                });
            });
        };
        DebeBackend.prototype.transformItemIn = function (collection, item, options) {
            var e_4, _a;
            var idField = this.options.idField;
            if (!item) {
                return item;
            }
            if (item[idField] === undefined || item[idField] === null) {
                item[idField] = generate();
                options.new.push(item[idField]);
            }
            else {
                options.existing.push(item[idField]);
            }
            if (typeof item[idField] !== 'string') {
                item[idField] = item[idField] + '';
            }
            try {
                for (var _b = __values(this.middlewares), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var middleware = _c.value;
                    if (middleware.transformItemIn) {
                        item = middleware.transformItemIn(collection, item);
                    }
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return item;
        };
        DebeBackend.prototype.transformItemOut = function (collection, item) {
            var e_5, _a;
            try {
                for (var _b = __values(this.middlewares), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var middleware = _c.value;
                    if (middleware.transformItemOut) {
                        item = middleware.transformItemOut(collection, item);
                    }
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_5) throw e_5.error; }
            }
            return item;
        };
        DebeBackend.prototype.listener = function (type, callback, options) {
            var e_6, _a;
            try {
                for (var _b = __values(this.middlewares), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var middleware = _c.value;
                    if (middleware.listener) {
                        return middleware.listener(type, options, callback);
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_6) throw e_6.error; }
            }
            throw new Error('No listener attached');
        };
        DebeBackend.prototype.query = function (collection, value) {
            var e_7, _a;
            try {
                for (var _b = __values(this.middlewares), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var middleware = _c.value;
                    if (middleware.query) {
                        value = middleware.query(collection, value);
                    }
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_7) throw e_7.error; }
            }
            return value;
        };
        DebeBackend.prototype.insert = function (collection, value, options) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, chunkMode, c, input, _a, _b, middleware, result_1, _c, e_8_1, result, transformed, _d, _e, middleware;
                var e_8, _f, e_9, _g;
                var _this = this;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            chunks = this.adapter.chunks || this.chunks;
                            chunkMode = this.adapter.chunkMode || this.chunkMode;
                            if (chunks && value.length > chunks) {
                                return [2, (chunkMode === 'sequencial' ? chunkSequencial : chunkParallel)(value, chunks, function (items) { return _this.insert(collection, items, __assign({}, options)); })];
                            }
                            if (!options.new) {
                                options.new = [];
                                options.existing = [];
                            }
                            c = this.collection(collection);
                            input = value.map(function (x) { return _this.transformItemIn(c, x, options); });
                            _h.label = 1;
                        case 1:
                            _h.trys.push([1, 8, 9, 10]);
                            _a = __values(this.middlewares), _b = _a.next();
                            _h.label = 2;
                        case 2:
                            if (!!_b.done) return [3, 7];
                            middleware = _b.value;
                            if (!middleware.beforeInsert) return [3, 6];
                            result_1 = middleware.beforeInsert(c, input, options);
                            _c = result_1;
                            if (!_c) return [3, 4];
                            return [4, result_1];
                        case 3:
                            _c = (_h.sent());
                            _h.label = 4;
                        case 4:
                            if (!_c) return [3, 6];
                            return [4, result_1];
                        case 5:
                            input = (_h.sent());
                            _h.label = 6;
                        case 6:
                            _b = _a.next();
                            return [3, 2];
                        case 7: return [3, 10];
                        case 8:
                            e_8_1 = _h.sent();
                            e_8 = { error: e_8_1 };
                            return [3, 10];
                        case 9:
                            try {
                                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
                            }
                            finally { if (e_8) throw e_8.error; }
                            return [7];
                        case 10: return [4, this.adapter.insert(c, input, options)];
                        case 11:
                            result = _h.sent();
                            transformed = result.map(function (x) { return _this.transformItemOut(c, x); });
                            try {
                                for (_d = __values(this.middlewares), _e = _d.next(); !_e.done; _e = _d.next()) {
                                    middleware = _e.value;
                                    if (middleware.afterInsert) {
                                        middleware.afterInsert(c, input, options, transformed);
                                    }
                                }
                            }
                            catch (e_9_1) { e_9 = { error: e_9_1 }; }
                            finally {
                                try {
                                    if (_e && !_e.done && (_g = _d.return)) _g.call(_d);
                                }
                                finally { if (e_9) throw e_9.error; }
                            }
                            return [2, result];
                    }
                });
            });
        };
        DebeBackend.prototype.remove = function (collection, value) {
            return __awaiter(this, void 0, void 0, function () {
                var c, _a, _b, middleware, v, _c, e_10_1, result, _d, _e, middleware;
                var e_10, _f, e_11, _g;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            c = this.collection(collection);
                            _h.label = 1;
                        case 1:
                            _h.trys.push([1, 8, 9, 10]);
                            _a = __values(this.middlewares), _b = _a.next();
                            _h.label = 2;
                        case 2:
                            if (!!_b.done) return [3, 7];
                            middleware = _b.value;
                            if (!middleware.beforeRemove) return [3, 6];
                            v = middleware.beforeRemove(c, value);
                            _c = v && v.then;
                            if (!_c) return [3, 4];
                            return [4, v];
                        case 3:
                            _c = (_h.sent());
                            _h.label = 4;
                        case 4:
                            if (!_c) return [3, 6];
                            return [4, v];
                        case 5: return [2, _h.sent()];
                        case 6:
                            _b = _a.next();
                            return [3, 2];
                        case 7: return [3, 10];
                        case 8:
                            e_10_1 = _h.sent();
                            e_10 = { error: e_10_1 };
                            return [3, 10];
                        case 9:
                            try {
                                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
                            }
                            finally { if (e_10) throw e_10.error; }
                            return [7];
                        case 10: return [4, this.adapter.remove(c, value)];
                        case 11:
                            result = _h.sent();
                            try {
                                for (_d = __values(this.middlewares), _e = _d.next(); !_e.done; _e = _d.next()) {
                                    middleware = _e.value;
                                    if (middleware.afterRemove) {
                                        middleware.afterRemove(c, value, result);
                                    }
                                }
                            }
                            catch (e_11_1) { e_11 = { error: e_11_1 }; }
                            finally {
                                try {
                                    if (_e && !_e.done && (_g = _d.return)) _g.call(_d);
                                }
                                finally { if (e_11) throw e_11.error; }
                            }
                            return [2, result];
                    }
                });
            });
        };
        DebeBackend.prototype.all = function (collection, value) {
            return __awaiter(this, void 0, void 0, function () {
                var c, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            c = this.collection(collection);
                            value = this.query(c, value);
                            return [4, this.adapter.all(c, value)];
                        case 1:
                            result = _a.sent();
                            return [2, this.transformItemOut(c, result)];
                    }
                });
            });
        };
        DebeBackend.prototype.count = function (collection, value) {
            return __awaiter(this, void 0, void 0, function () {
                var c, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            c = this.collection(collection);
                            value = this.query(c, value);
                            return [4, this.adapter.count(c, value)];
                        case 1:
                            result = _a.sent();
                            return [2, result];
                    }
                });
            });
        };
        DebeBackend.prototype.get = function (collection, value) {
            return __awaiter(this, void 0, void 0, function () {
                var c, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            c = this.collection(collection);
                            return [4, this.adapter.get(c, value)];
                        case 1:
                            result = _a.sent();
                            return [2, this.transformItemOut(c, result)];
                    }
                });
            });
        };
        return DebeBackend;
    }(DebeDispatcher));

    function ensureSync(db) {
        var backend = db.dispatcher;
        if (backend.middlewares) {
            addMiddleware(backend, {
                name: 'sync',
                collection: function (collection) {
                    if (collection['sync'] && collection['sync'] === 'delta') {
                        addPlugin(collection, 'delta');
                    }
                    return collection;
                },
                collections: function (collections) {
                    collections[syncstateTable] = ensureCollection({
                        name: syncstateTable,
                        fields: {
                            state: 'json'
                        }
                    });
                    return collections;
                }
            });
            debeDelta.deltaPlugin(backend);
        }
    }

    var Sync = (function () {
        function Sync(db, _a) {
            var _b = __read(_a === void 0 ? [] : _a, 3), _c = _b[0], hostname = _c === void 0 ? 'localhost' : _c, _d = _b[1], port = _d === void 0 ? 8000 : _d, _e = _b[2], secure = _e === void 0 ? undefined : _e;
            this.db = db;
            this.syncState = new SyncState(db);
            ensureSync(this.db);
            this.db['sync'] = this;
            this.socket = debeSocket.create({
                secure: secure === true || secure === false ? secure : port === 443,
                hostname: hostname,
                port: port
            });
        }
        Sync.prototype.initialize = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.db.initialize()];
                        case 1:
                            _a.sent();
                            this.loop();
                            return [2, this];
                    }
                });
            });
        };
        Object.defineProperty(Sync.prototype, "initialSync", {
            get: function () {
                return this.engine.initialSyncComplete;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sync.prototype, "isSyncing", {
            get: function () {
                return this.engine.isSyncing;
            },
            enumerable: true,
            configurable: true
        });
        Sync.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this['_close']) return [3, 2];
                            return [4, this['_close']()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            this.socket.disconnect();
                            return [4, this.db.close()];
                        case 3:
                            _a.sent();
                            return [2];
                    }
                });
            });
        };
        Sync.prototype.disconnect = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this['_close']) return [3, 2];
                            return [4, this['_close']()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            this.socket.disconnect();
                            return [2];
                    }
                });
            });
        };
        Sync.prototype.connect = function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections, isDelta, keys;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.db.initialize()];
                        case 1:
                            _a.sent();
                            return [4, this.syncState.init()];
                        case 2:
                            _a.sent();
                            this.engine = new SyncEngine(this.socket, this.db, this.syncState);
                            collections = this.db.dispatcher.collections;
                            isDelta = function (key) { return collections[key]['sync'] === 'delta'; };
                            keys = Object.keys(collections).filter(function (x) { return collections[x]['sync']; });
                            this.engine.initial(keys, isDelta);
                            this['_close'] = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2, this.engine.close()];
                            }); }); };
                            return [2];
                    }
                });
            });
        };
        Sync.prototype.listener = function () { };
        Object.defineProperty(Sync.prototype, "state", {
            get: function () {
                return this.socket.state;
            },
            enumerable: true,
            configurable: true
        });
        Sync.prototype.onConnectionState = function (func) {
            var _this = this;
            var cancel = false;
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, event_1, e_1_1;
                var e_1, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 5, 6, 11]);
                            _a = __asyncValues(this.socket.listener('connect'));
                            _d.label = 1;
                        case 1: return [4, _a.next()];
                        case 2:
                            if (!(_b = _d.sent(), !_b.done)) return [3, 4];
                            event_1 = _b.value;
                            if (cancel) {
                                return [2];
                            }
                            func(this.state);
                            _d.label = 3;
                        case 3: return [3, 1];
                        case 4: return [3, 11];
                        case 5:
                            e_1_1 = _d.sent();
                            e_1 = { error: e_1_1 };
                            return [3, 11];
                        case 6:
                            _d.trys.push([6, , 9, 10]);
                            if (!(_b && !_b.done && (_c = _a.return))) return [3, 8];
                            return [4, _c.call(_a)];
                        case 7:
                            _d.sent();
                            _d.label = 8;
                        case 8: return [3, 10];
                        case 9:
                            if (e_1) throw e_1.error;
                            return [7];
                        case 10: return [7];
                        case 11: return [2];
                    }
                });
            }); })();
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, event_2, e_2_1;
                var e_2, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 5, 6, 11]);
                            _a = __asyncValues(this.socket.listener('disconnect'));
                            _d.label = 1;
                        case 1: return [4, _a.next()];
                        case 2:
                            if (!(_b = _d.sent(), !_b.done)) return [3, 4];
                            event_2 = _b.value;
                            if (cancel) {
                                return [2];
                            }
                            func(this.state);
                            _d.label = 3;
                        case 3: return [3, 1];
                        case 4: return [3, 11];
                        case 5:
                            e_2_1 = _d.sent();
                            e_2 = { error: e_2_1 };
                            return [3, 11];
                        case 6:
                            _d.trys.push([6, , 9, 10]);
                            if (!(_b && !_b.done && (_c = _a.return))) return [3, 8];
                            return [4, _c.call(_a)];
                        case 7:
                            _d.sent();
                            _d.label = 8;
                        case 8: return [3, 10];
                        case 9:
                            if (e_2) throw e_2.error;
                            return [7];
                        case 10: return [7];
                        case 11: return [2];
                    }
                });
            }); })();
            return function () { return (cancel = true); };
        };
        Sync.prototype.loop = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.state !== 'open')) return [3, 2];
                            return [4, this.socket.listener('connect').once()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            if (this.state !== 'open') {
                                this.loop();
                            }
                            else {
                                this.connect();
                            }
                            return [2];
                    }
                });
            });
        };
        return Sync;
    }());

    exports.CHANNELS = CHANNELS;
    exports.Sync = Sync;
    exports.batchSize = batchSize;
    exports.batchTransfer = batchTransfer;
    exports.defaultInterval = defaultInterval;
    exports.getBigger = getBigger;
    exports.getLastItemRev = getLastItemRev;
    exports.hashCode = hashCode;
    exports.maxRetries = maxRetries;
    exports.maxTimeout = maxTimeout;
    exports.syncstateTable = syncstateTable;
    exports.waitFor = waitFor;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
