import * as tslib_1 from "tslib";
import { syncstateTable } from '../constants';
var SyncState = (function () {
    function SyncState(db) {
        var _this = this;
        this.state = {};
        this.local = function (collection) {
            if (!_this.state[collection]) {
                return undefined;
            }
            return _this.state[collection].local;
        };
        this.remote = function (collection) {
            if (!_this.state[collection]) {
                return undefined;
            }
            return _this.state[collection].remote;
        };
        this.promise = Promise.resolve();
        this.init = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var state;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.db.get(syncstateTable)];
                    case 1:
                        state = _a.sent();
                        if (state) {
                            this.state = state;
                        }
                        return [2];
                }
            });
        }); };
        this.update = function (collection, local, remote) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                if (!this.state[collection]) {
                    this.state[collection] = {};
                }
                if (local) {
                    this.state[collection].local = local;
                }
                if (remote) {
                    this.state[collection].remote = remote;
                }
                this.promise = this.promise.then(function () {
                    return _this.db.insert(syncstateTable, tslib_1.__assign({}, _this.state));
                });
                return [2];
            });
        }); };
        this.db = db;
    }
    return SyncState;
}());
export { SyncState };
//# sourceMappingURL=index.js.map