import * as tslib_1 from "tslib";
import { batchSize } from '../constants';
import { CHANNELS } from '../types';
import { batchTransfer } from '../utils';
export var basic = {
    initialDown: function (collection, since, count, sync) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, remoteChanges;
            var _this = this;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, batchTransfer({
                            fetchCount: function () { return count; },
                            fetchItems: function (page) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                return tslib_1.__generator(this, function (_a) {
                                    return [2, sync.socket.invoke(CHANNELS.FETCH_INITIAL, {
                                            type: collection,
                                            since: since,
                                            page: page
                                        })];
                                });
                            }); },
                            shouldCancel: function () { return sync.isClosing; }
                        })];
                    case 1:
                        _a = tslib_1.__read.apply(void 0, [_b.sent(), 1]), remoteChanges = _a[0];
                        return [2, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                var options, o;
                                return tslib_1.__generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            if (!(remoteChanges.length && !sync.isClosing)) return [3, 2];
                                            options = {
                                                synced: 'client'
                                            };
                                            return [4, sync.db.insert(collection, remoteChanges, options)];
                                        case 1:
                                            _a.sent();
                                            o = remoteChanges[remoteChanges.length - 1];
                                            return [2, [undefined, o && o[2]]];
                                        case 2: return [2, [undefined, undefined]];
                                    }
                                });
                            }); }];
                }
            });
        });
    },
    initialUp: function (collection, since, count, sync) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var latestResult, latestUpload, err_1;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        latestResult = undefined;
                        latestUpload = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, batchTransfer({
                                fetchCount: function () { return count; },
                                fetchItems: function (page) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                    return tslib_1.__generator(this, function (_a) {
                                        return [2, sync.db
                                                .all(collection, {
                                                where: since ? ['rev > ?', since] : undefined,
                                                orderBy: ['rev ASC', 'id ASC'],
                                                limit: batchSize,
                                                offset: page * batchSize
                                            })
                                                .then(function (x) {
                                                if (x.length) {
                                                    latestUpload = x[x.length - 1].rev;
                                                }
                                                return x;
                                            })];
                                    });
                                }); },
                                transferItems: function (items) { return basic.up(collection, items, {}, sync); },
                                shouldCancel: function () { return sync.isClosing; }
                            })];
                    case 2:
                        _a.sent();
                        return [2, [latestUpload, latestResult ? latestResult.latestRev : undefined]];
                    case 3:
                        err_1 = _a.sent();
                        return [2, [undefined, undefined]];
                    case 4: return [2];
                }
            });
        });
    },
    listen: function (sync) {
        var _this = this;
        var channel = sync.socket.subscribe(CHANNELS.SUBSCRIBE_CHANGES);
        (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var channel_1, channel_1_1, data, _a, type, items, _b, options, release, lastRemoteRev, newItems, lastLocalRev, e_1_1;
            var e_1, _c;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 7, 8, 13]);
                        channel_1 = tslib_1.__asyncValues(channel);
                        _d.label = 1;
                    case 1: return [4, channel_1.next()];
                    case 2:
                        if (!(channel_1_1 = _d.sent(), !channel_1_1.done)) return [3, 6];
                        data = channel_1_1.value;
                        if (sync.isClosing) {
                            return [2];
                        }
                        return [4, sync.initialSyncComplete];
                    case 3:
                        _d.sent();
                        _a = tslib_1.__read(data, 3), type = _a[0], items = _a[1], _b = _a[2], options = _b === void 0 ? {} : _b;
                        release = sync.registerTask();
                        options.synced = sync.socket.id;
                        lastRemoteRev = items[items.length - 1] && items[items.length - 1].rev;
                        return [4, sync.db.insert(type, items, options)];
                    case 4:
                        newItems = _d.sent();
                        lastLocalRev = newItems[newItems.length - 1] && newItems[newItems.length - 1].rev;
                        sync.syncState.update(type, lastLocalRev, lastRemoteRev);
                        release();
                        _d.label = 5;
                    case 5: return [3, 1];
                    case 6: return [3, 13];
                    case 7:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3, 13];
                    case 8:
                        _d.trys.push([8, , 11, 12]);
                        if (!(channel_1_1 && !channel_1_1.done && (_c = channel_1.return))) return [3, 10];
                        return [4, _c.call(channel_1)];
                    case 9:
                        _d.sent();
                        _d.label = 10;
                    case 10: return [3, 12];
                    case 11:
                        if (e_1) throw e_1.error;
                        return [7];
                    case 12: return [7];
                    case 13: return [2];
                }
            });
        }); })();
        return {
            wait: new Promise(function (yay) { return setTimeout(yay, 10); })
        };
    },
    up: function (collection, items, options, sync) {
        if (sync.isClosing) {
            return Promise.resolve();
        }
        return sync.socket
            .invoke(CHANNELS.SEND, [collection, items])
            .catch(function (err) {
            if (!sync.isClosing) {
                throw err;
            }
        });
    }
};
//# sourceMappingURL=basic.js.map