import * as tslib_1 from "tslib";
import { batchSize } from '../constants';
import { CHANNELS } from '../types';
import { merge } from 'debe-delta';
import { batchTransfer } from '../utils';
var SEND_DELTA = CHANNELS.SEND_DELTA, FETCH_MISSING_DELTA = CHANNELS.FETCH_MISSING_DELTA;
export var delta = {
    initialDown: function (collection, since, count, sync) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, remoteChanges;
            var _this = this;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, batchTransfer({
                            fetchCount: function () { return count; },
                            fetchItems: function (page) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                return tslib_1.__generator(this, function (_a) {
                                    return [2, sync.socket.invoke(CHANNELS.FETCH_INITIAL_DELTA, {
                                            type: collection,
                                            since: since,
                                            page: page
                                        })];
                                });
                            }); },
                            shouldCancel: function () { return sync.isClosing; }
                        })];
                    case 1:
                        _a = tslib_1.__read.apply(void 0, [_b.sent(), 1]), remoteChanges = _a[0];
                        if (remoteChanges.length && !sync.isClosing) {
                            return [2, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                    var options, o;
                                    return tslib_1.__generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                options = {
                                                    synced: 'client'
                                                };
                                                return [4, merge(sync.db, collection, remoteChanges, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                                            case 1:
                                                _a.sent();
                                                o = remoteChanges[remoteChanges.length - 1];
                                                return [2, [undefined, o && o[2]]];
                                        }
                                    });
                                }); }];
                        }
                        return [2, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2, [undefined, undefined]];
                            }); }); }];
                }
            });
        });
    },
    initialUp: function (collection, since, count, sync) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var latestResult, latestUpload, err_1;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        latestResult = undefined;
                        latestUpload = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, batchTransfer({
                                fetchCount: function () { return count; },
                                fetchItems: function (page) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                    return tslib_1.__generator(this, function (_a) {
                                        return [2, sync.db
                                                .all(collection, {
                                                where: since ? ['rev > ?', since] : undefined,
                                                orderBy: ['rev ASC', 'id ASC'],
                                                limit: batchSize,
                                                offset: page * batchSize
                                            })
                                                .then(function (x) {
                                                if (x.length) {
                                                    latestUpload = x[x.length - 1].rev;
                                                }
                                                return x;
                                            })];
                                    });
                                }); },
                                transferItems: function (items) {
                                    return delta
                                        .up(collection, items, {
                                        delta: items.map(function (x) { return [x.id, x['merge'], x.rev]; })
                                    }, sync)
                                        .then(function (x) {
                                        latestResult = x;
                                        return x;
                                    });
                                },
                                shouldCancel: function () { return sync.isClosing; }
                            })];
                    case 2:
                        _a.sent();
                        return [2, [latestUpload, latestResult ? latestResult.latestRev : undefined]];
                    case 3:
                        err_1 = _a.sent();
                        return [2, [undefined, undefined]];
                    case 4: return [2];
                }
            });
        });
    },
    listen: function (sync) {
        var _this = this;
        var channel = sync.socket.subscribe(CHANNELS.SUBSCRIBE_DELTA_CHANGES);
        (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var channel_1, channel_1_1, data, release, _a, type, items, _b, options, newItems, result, o0, o, e_1_1;
            var e_1, _c;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 10, 11, 16]);
                        channel_1 = tslib_1.__asyncValues(channel);
                        _d.label = 1;
                    case 1: return [4, channel_1.next()];
                    case 2:
                        if (!(channel_1_1 = _d.sent(), !channel_1_1.done)) return [3, 9];
                        data = channel_1_1.value;
                        if (sync.isClosing) {
                            return [2];
                        }
                        return [4, sync.initialSyncComplete];
                    case 3:
                        _d.sent();
                        release = sync.registerTask();
                        _a = tslib_1.__read(data, 3), type = _a[0], items = _a[1], _b = _a[2], options = _b === void 0 ? {} : _b;
                        options.synced = sync.socket.id;
                        return [4, merge(sync.db, type, items, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                    case 4:
                        newItems = _d.sent();
                        if (!options.unsucessful.length) return [3, 7];
                        return [4, sync.socket.invoke(FETCH_MISSING_DELTA, [
                                type,
                                options.unsucessful
                            ])];
                    case 5:
                        result = _d.sent();
                        return [4, merge(sync.db, type, result, options).catch(function (x) { return console.error('Error while client.insert', x); })];
                    case 6:
                        newItems = _d.sent();
                        _d.label = 7;
                    case 7:
                        o0 = newItems[newItems.length - 1];
                        o = items[items.length - 1];
                        sync.syncState.update(type, o0 ? o0.rev : undefined, o && o[2]);
                        release();
                        _d.label = 8;
                    case 8: return [3, 1];
                    case 9: return [3, 16];
                    case 10:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3, 16];
                    case 11:
                        _d.trys.push([11, , 14, 15]);
                        if (!(channel_1_1 && !channel_1_1.done && (_c = channel_1.return))) return [3, 13];
                        return [4, _c.call(channel_1)];
                    case 12:
                        _d.sent();
                        _d.label = 13;
                    case 13: return [3, 15];
                    case 14:
                        if (e_1) throw e_1.error;
                        return [7];
                    case 15: return [7];
                    case 16: return [2];
                }
            });
        }); })();
        return {
            wait: new Promise(function (yay) { return setTimeout(yay, 10); })
        };
    },
    up: function (collection, items, options, sync) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, _b, failed, latestRev, missing;
            return tslib_1.__generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (sync.isClosing) {
                            return [2];
                        }
                        return [4, sync.socket.invoke(SEND_DELTA, [collection, options['delta']])];
                    case 1:
                        _a = _c.sent(), _b = _a.failed, failed = _b === void 0 ? [] : _b, latestRev = _a.latestRev;
                        if (sync.isClosing) {
                            return [2];
                        }
                        if (!failed.length) return [3, 4];
                        return [4, sync.db.all(collection, {
                                id: failed,
                                select: ['id', 'merge']
                            })];
                    case 2:
                        missing = _c.sent();
                        if (sync.isClosing) {
                            return [2];
                        }
                        return [4, sync.socket
                                .invoke(SEND_DELTA, [collection, missing.map(function (x) { return [x.id, x['merge']]; })])
                                .then(function (x) { return (x.latestRev > latestRev ? x.latestRev : latestRev); })];
                    case 3:
                        latestRev = _c.sent();
                        _c.label = 4;
                    case 4: return [2, latestRev];
                }
            });
        });
    }
};
//# sourceMappingURL=delta.js.map