import { Debe, IUnlisten } from 'debe';
import { ISocket } from 'debe-socket';
import { SyncState } from '../state';
export declare class SyncEngine {
    syncState: SyncState;
    socket: ISocket;
    db: Debe;
    constructor(socket: ISocket, db: Debe, state: SyncState);
    initialSyncComplete: Promise<void>;
    readonly isInitialComplete: boolean;
    readonly isSyncing: boolean;
    private cancels;
    private tasks;
    isClosing: boolean;
    initial(collections: string[], isDelta: Function): void;
    close(): void;
    listenToSync(): void;
    getRemoteChangeCount(socket: ISocket, collections: string[], syncState: SyncState): Promise<{}>;
    getLocalChangeCount(db: Debe, collections: string[], syncState: any): Promise<{}>;
    getTaskKey(): string;
    registerTask(initialKey?: string): () => void;
    listenToDatabase(collections: string[], isDelta: Function): IUnlisten;
    initialSync(collections: string[], isDelta: Function): Promise<void>;
}
