import * as tslib_1 from "tslib";
import { Sync } from 'debe-sync';
import { MemoryDebe } from 'debe-memory';
import { SyncServer } from 'debe-sync-server';
import { create } from 'debe-socket';
import http from 'http';
import { attach } from 'debe-socket-server';
export var schema = [
    {
        name: 'lorem',
        index: ['name'],
        sync: 'simple'
    }
];
export var alphabet = [
    'a',
    'b',
    'c',
    'd',
    'e',
    'f',
    'g',
    'h',
    'i',
    'j',
    'k',
    'l'
];
export function generateItemsInto(db, count, prefix) {
    if (count === void 0) { count = 1000; }
    if (prefix === void 0) { prefix = ''; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var items, x;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    items = [];
                    for (x = 0; x < count; x++) {
                        items.push({
                            name: prefix + ("" + x).padStart(("" + count).length + 1, '0')
                        });
                    }
                    return [4, db.insert('lorem', items)];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
export function spawnServer(port, syncTo) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var db, target;
        return tslib_1.__generator(this, function (_a) {
            db = new MemoryDebe(schema);
            target = syncTo ? ['localhost', syncTo] : undefined;
            return [2, new SyncServer(db, port, target).initialize()];
        });
    });
}
export function spawnClient(port) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var db;
        return tslib_1.__generator(this, function (_a) {
            db = new MemoryDebe(schema);
            return [2, new Sync(db, ['localhost', port]).initialize()];
        });
    });
}
export function generateClients(port, numberOfClients) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var clients, i, _a, _b;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    clients = [];
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < numberOfClients)) return [3, 4];
                    _b = (_a = clients).push;
                    return [4, spawnClient(port)];
                case 2:
                    _b.apply(_a, [_c.sent()]);
                    _c.label = 3;
                case 3:
                    i++;
                    return [3, 1];
                case 4: return [2, clients];
            }
        });
    });
}
export function isEqual() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var previous, args_1, args_1_1, db, items, arr, e_1_1;
        var e_1, _a;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    previous = undefined;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, 7, 8]);
                    args_1 = tslib_1.__values(args), args_1_1 = args_1.next();
                    _b.label = 2;
                case 2:
                    if (!!args_1_1.done) return [3, 5];
                    db = args_1_1.value;
                    return [4, db.all('lorem', { orderBy: ['name ASC'] })];
                case 3:
                    items = _b.sent();
                    arr = tslib_1.__spread(new Set(tslib_1.__spread(items.map(function (x) { return x.name; }))));
                    if (previous !== undefined && previous.join(',') !== arr.join(',')) {
                        return [2, false];
                    }
                    previous = arr;
                    _b.label = 4;
                case 4:
                    args_1_1 = args_1.next();
                    return [3, 2];
                case 5: return [3, 8];
                case 6:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3, 8];
                case 7:
                    try {
                        if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7];
                case 8: return [2, true];
            }
        });
    });
}
export function awaitIsEqual(maxTries) {
    if (maxTries === void 0) { maxTries = 10; }
    var dbs = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        dbs[_i - 1] = arguments[_i];
    }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var i;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < maxTries)) return [3, 5];
                    return [4, isEqual.apply(void 0, tslib_1.__spread(dbs))];
                case 2:
                    if (_a.sent()) {
                        return [2, true];
                    }
                    return [4, new Promise(function (yay) { return setTimeout(yay, 1000); })];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    i++;
                    return [3, 1];
                case 5: return [2, false];
            }
        });
    });
}
export function createSimpleSocket(port) {
    var socket = create({
        hostname: 'localhost',
        port: port
    });
    return socket;
}
export function createSimpleServer(port) {
    var _this = this;
    var httpServer = http.createServer();
    var agServer = attach(httpServer);
    httpServer.listen(port);
    return {
        server: agServer,
        close: function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agServer.closeAllListeners();
                        return [4, agServer.close()];
                    case 1:
                        _a.sent();
                        httpServer.close();
                        return [2];
                }
            });
        }); }
    };
}
//# sourceMappingURL=index.js.map