import { IItem, IGetItem, IInsertItem, Debe } from 'debe';
import { IChanges } from 'debe-delta';
export declare const CHANNELS: {
    SEND: string;
    SEND_DELTA: string;
    COUNT_INITIAL: string;
    COUNT_INITIAL_DELTA: string;
    FETCH_INITIAL: string;
    FETCH_INITIAL_DELTA: string;
    FETCH_MISSING_DELTA: string;
    SUBSCRIBE_CHANGES: string;
    SUBSCRIBE_DELTA_CHANGES: string;
};
export interface ISyncItem extends IGetItem {
    remote?: string;
    local?: string;
}
export interface ICountInitialChanges {
    type: string;
    since?: string;
    where?: [string, ...any[]];
}
export interface IInitialFetchChanges {
    type: string;
    since?: string;
    where?: [string, ...any[]];
    page?: number;
}
export declare type IAddress = [string] | [] | [string, number] | [string, number, boolean];
export declare type ISendChanges = [string, IInsertItem[], any?] | [string, IInsertItem[]];
export declare type ISendDelta = [string, [string, IChanges][], any?];
export interface IListenToChanges {
    type: string;
    clientID: string;
    emit: (err: any, items: IItem[]) => void;
}
export interface ISync {
    countInitialChanges: (payload: ICountInitialChanges) => Promise<number>;
    initialFetchChanges: (payload: IInitialFetchChanges) => Promise<IItem[]>;
    sendChanges: (payload: ISendChanges) => Promise<string | undefined>;
}
export interface ISyncAdapter {
    initialDownload: () => void;
    initialUpload: () => void;
    listenToSubscription: (db: Debe) => Promise<void>;
}
