import { IGetItem } from 'debe';
export declare function hashCode(str?: string): number;
export declare function getLastItemRev(items: IGetItem[] | undefined, revField: string, comparer?: string): string | undefined;
export declare const maxRetries = 5;
export declare const maxTimeout = 2500;
export declare const defaultInterval: (tries: number) => 100 | 200 | 400 | 800 | 1600 | 3200;
export declare function waitFor<T>(cb: () => any, { interval }?: {
    interval?: ((tries: number) => number) | number;
    fail?: boolean;
}): Promise<T>;
export declare function getBigger(comparer0?: string, comparer1?: string): string | undefined;
declare type IFetchCount = () => Promise<number> | number;
declare type IFetchItems<TResult = any> = (page: number) => Promise<TResult[]> | TResult[];
declare type ITransferItems<TInput, TResult = TInput> = (items: TInput[]) => Promise<TResult[]>;
export declare function batchTransfer<TFetchResult = any, TTransferResult = any>({ fetchCount, fetchItems, transferItems, reporter, shouldCancel }: {
    fetchCount: IFetchCount;
    fetchItems: IFetchItems<TFetchResult>;
    transferItems?: ITransferItems<TFetchResult, TTransferResult>;
    reporter?: (percent: number) => void;
    shouldCancel?: () => boolean;
}): Promise<[TFetchResult[], TTransferResult[]]>;
export {};
