import * as tslib_1 from "tslib";
export function hashCode(str) {
    if (str === void 0) { str = ''; }
    var hash = 0, i, chr;
    if (str.length === 0)
        return hash;
    for (i = 0; i < str.length; i++) {
        chr = str.charCodeAt(i);
        hash = (hash << 5) - hash + chr;
        hash |= 0;
    }
    return hash;
}
export function getLastItemRev(items, revField, comparer) {
    if (items === void 0) { items = []; }
    var result = items[items.length - 1]
        ? items[items.length - 1][revField]
        : undefined;
    if (!comparer || result > comparer) {
        return result;
    }
    return comparer;
}
export var maxRetries = 5;
export var maxTimeout = 2500;
export var defaultInterval = function (tries) {
    switch (tries) {
        case 0:
            return 100;
        case 1:
            return 200;
        case 2:
            return 400;
        case 3:
            return 800;
        case 4:
            return 1600;
        default:
            return 3200;
    }
};
export function waitFor(cb, _a) {
    var _b = (_a === void 0 ? {} : _a).interval, interval = _b === void 0 ? defaultInterval : _b;
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var tries, result;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    tries = 0;
                    _c.label = 1;
                case 1: return [4, cb()];
                case 2:
                    if (!(!(result = _c.sent()) && tries <= maxRetries)) return [3, 4];
                    tries += 1;
                    return [4, new Promise(function (yay) {
                            return setTimeout(yay, typeof interval === 'function' ? interval(tries) : interval);
                        })];
                case 3:
                    _c.sent();
                    return [3, 1];
                case 4: return [2, Promise.resolve(result)];
            }
        });
    });
}
export function getBigger(comparer0, comparer1) {
    if (!comparer0 || !comparer1) {
        return undefined;
    }
    if (!comparer1 || comparer0 > comparer1) {
        return comparer0;
    }
    return comparer1;
}
export function batchTransfer(_a) {
    var fetchCount = _a.fetchCount, fetchItems = _a.fetchItems, transferItems = _a.transferItems, reporter = _a.reporter, shouldCancel = _a.shouldCancel;
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var canceled, changeCount, current, page, items, transferred, changes, _b, _c;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    canceled = shouldCancel ? shouldCancel : function () { return false; };
                    return [4, fetchCount()];
                case 1:
                    changeCount = _d.sent();
                    current = changeCount;
                    page = 0;
                    items = [];
                    transferred = [];
                    _d.label = 2;
                case 2:
                    if (!(current > 0)) return [3, 8];
                    return [4, fetchItems(page)];
                case 3:
                    changes = _d.sent();
                    if (!(changes.length && !canceled())) return [3, 6];
                    if (!transferItems) return [3, 5];
                    _c = (_b = transferred).concat;
                    return [4, transferItems(changes)];
                case 4:
                    transferred = _c.apply(_b, [_d.sent()]);
                    _d.label = 5;
                case 5:
                    items = items.concat(changes);
                    return [3, 7];
                case 6: return [3, 8];
                case 7:
                    current = current - changes.length;
                    page = page + 1;
                    if (reporter) {
                        reporter(Math.abs((100 / changeCount) * current - 100));
                    }
                    return [3, 2];
                case 8:
                    if (transferItems) {
                        return [2, [items, transferred]];
                    }
                    return [2, [items, []]];
            }
        });
    });
}
//# sourceMappingURL=index.js.map